(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("beeftools")) : typeof define === "function" && define.amd ? define(["exports", "beeftools"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.socialite = {}, global.beeftools));
})(this, function(exports2, beeftools) {
  "use strict";var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};

  var _networks, _validateUrl, validateUrl_fn, _getMinimumResult, getMinimumResult_fn;
  var UrlCaptureId = /* @__PURE__ */ ((UrlCaptureId2) => {
    UrlCaptureId2["Scheme"] = "scheme";
    UrlCaptureId2["Domain"] = "domain";
    UrlCaptureId2["Tldomain"] = "tldomain";
    UrlCaptureId2["Port"] = "port";
    UrlCaptureId2["Path"] = "path";
    UrlCaptureId2["Parameters"] = "parameters";
    UrlCaptureId2["Anchor"] = "anchor";
    return UrlCaptureId2;
  })(UrlCaptureId || {});
  var MatchUserSource = /* @__PURE__ */ ((MatchUserSource2) => {
    MatchUserSource2["Subdomain"] = "subdomain";
    MatchUserSource2["Path"] = "path";
    return MatchUserSource2;
  })(MatchUserSource || {});
  function constructFullLineRegExp(...captureGroups) {
    return new RegExp(["^", ...captureGroups, "$"].join(""));
  }
  const urlCaptureGroup = {
    scheme: `(?<${UrlCaptureId.Scheme}>https?://)?`,
    domain: `(?<${UrlCaptureId.Domain}>[\\w\\.-]+?)`,
    tldomain: `(?<${UrlCaptureId.Tldomain}>\\.\\w{2,5})?`,
    port: `(?<${UrlCaptureId.Port}>:\\d+?)?`,
    path: `(?<${UrlCaptureId.Path}>\\/.*?(?=[\\?|#]?))?`,
    parameters: `(?<${UrlCaptureId.Parameters}>\\?.+?(?=[#]?))?`,
    anchor: `(?<${UrlCaptureId.Anchor}>\\#.+?)?`
  };
  const urlRegExp = constructFullLineRegExp(
    urlCaptureGroup.scheme,
    urlCaptureGroup.domain,
    urlCaptureGroup.tldomain,
    urlCaptureGroup.port,
    urlCaptureGroup.path,
    urlCaptureGroup.parameters,
    urlCaptureGroup.anchor
  );
  const schemeRegExp = /^https?:\/\//;
  const profileReplacement = {
    user: "{REPLACE_PROFILE_USER}",
    prefix: "{REPLACE_PROFILE_PREFIX}"
  };
  const defaultUserMatcher = {
    subdomain: /[^.]+/,
    path: /[^/]+/
  };
  const discordPreferredUrls = {
    users: `https://discordapp.com/users/${profileReplacement.user}`,
    channels: `https://discord.com/channels/${profileReplacement.user}`,
    vanity: `https://discord.gg/${profileReplacement.user}`,
    // TODO: This result should not be supported
    default: `https://discord.com/${profileReplacement.user}`
  };
  const behance = {
    id: "behance",
    preferredUrl: `https://behance.net/${profileReplacement.user}`,
    matcher: {
      domain: /behance/
    }
  };
  const devto = {
    id: "dev_to",
    preferredUrl: `https://dev.to/${profileReplacement.user}`,
    matcher: {
      domain: /^dev$/
    }
  };
  const discord = {
    id: "discord",
    preferredUrl: discordPreferredUrls.users,
    matcher: {
      domain: /discord/,
      user: /^\/(?:users\/|channels\/)?([^/]+)/
      // TODO: If we want to support capturing EVERYTHING after
      // the first `/` (necessary for capturing the `channelid`),
      // then we would need to use the following:
      // user: /^\/(?:users\/|channels\/)?(.+)/,
    }
  };
  const dribbble = {
    id: "dribbble",
    preferredUrl: `https://dribbble.com/${profileReplacement.user}`,
    matcher: {
      domain: /dribbble/
    }
  };
  const exercism = {
    id: "exercism",
    preferredUrl: `https://exercism.io/profiles/${profileReplacement.user}`,
    matcher: {
      domain: /exercism/,
      user: /^(?:\/profiles\/)([^/]+)/
    }
  };
  const facebook = {
    id: "facebook",
    preferredUrl: `https://facebook.com/${profileReplacement.user}`,
    appUrl: `https://m.facebook.com/${profileReplacement.user}`,
    matcher: {
      domain: /facebook/
    }
  };
  const github = {
    id: "github",
    preferredUrl: `https://github.com/${profileReplacement.user}`,
    matcher: {
      domain: /github/
    }
  };
  const instagram = {
    id: "instagram",
    preferredUrl: `https://instagram.com/${profileReplacement.user}`,
    appUrl: `https://m.instagram.com/${profileReplacement.user}`,
    matcher: {
      domain: /instagram/
    }
  };
  const keybase = {
    id: "keybase",
    preferredUrl: `https://keybase.io/${profileReplacement.user}`,
    matcher: {
      domain: /keybase/
    }
  };
  const linkedin = {
    id: "linkedin",
    preferredUrl: `https://linkedin.com/in/${profileReplacement.user}`,
    appUrl: `https://linkedin.com/mwlite/in/${profileReplacement.user}`,
    matcher: {
      domain: /linkedin/,
      user: /^\/(?:mwlite|in)\/([^/]+)/
    }
  };
  const socialitePrefix = {
    medium: "@",
    tiktok: "@",
    twitter: "@"
  };
  const { medium: prefix$2 } = socialitePrefix;
  const medium = {
    id: "medium",
    preferredUrl: `https://medium.com/${prefix$2}${profileReplacement.user}`,
    matcher: {
      domain: /medium/,
      user: `${prefix$2}[^\\/]+`
    },
    prefix: prefix$2
  };
  const onlyfans = {
    id: "onlyfans",
    preferredUrl: `https://onlyfans.com/${profileReplacement.user}`,
    matcher: {
      domain: /onlyfans/,
      // Unless we want to qualify this with a `prefix`,
      // we probably do not need to include the `user` prop.
      user: `[^\\/]+`
    }
  };
  const patreon = {
    id: "patreon",
    preferredUrl: `https://patreon.com/${profileReplacement.user}`,
    matcher: {
      domain: /patreon/
    }
  };
  const pinterest = {
    id: "pinterest",
    preferredUrl: `https://pinterest.com/${profileReplacement.user}`,
    matcher: {
      domain: /pinterest/
    }
  };
  const reddit = {
    id: "reddit",
    preferredUrl: `https://reddit.com/user/${profileReplacement.user}`,
    matcher: {
      domain: /reddit/,
      user: /^(?:\/user\/)([^/]+)/
    }
  };
  const stackoverflow = {
    id: "stackoverflow",
    preferredUrl: `https://stackoverflow.com/users/${profileReplacement.user}`,
    matcher: {
      domain: /stackoverflow/,
      user: /^(?:\/users\/)(?:\d+?[/])?([^/]+)/
    }
  };
  const substack = {
    id: "substack",
    preferredUrl: `https://${profileReplacement.user}.substack.com`,
    matcher: {
      domain: /substack/,
      userSource: MatchUserSource.Subdomain
    }
  };
  const telegram = {
    id: "telegram",
    preferredUrl: `https://t.me/${profileReplacement.user}`,
    matcher: {
      domain: /telegram|t$/
    }
  };
  const { tiktok: prefix$1 } = socialitePrefix;
  const tiktok = {
    id: "tiktok",
    preferredUrl: `https://tiktok.com/${prefix$1}${profileReplacement.user}`,
    matcher: {
      domain: /tiktok/,
      user: `${prefix$1}[^\\/]+`
    },
    prefix: prefix$1
  };
  const twitch = {
    id: "twitch",
    preferredUrl: `https://twitch.tv/${profileReplacement.user}`,
    appUrl: `https://m.twitch.tv/${profileReplacement.user}`,
    matcher: {
      domain: /twitch/
    }
  };
  const { twitter: prefix } = socialitePrefix;
  const twitter = {
    id: "twitter",
    preferredUrl: `https://twitter.com/${prefix}${profileReplacement.user}`,
    appUrl: `https://mobile.twitter.com/${prefix}${profileReplacement.user}`,
    matcher: {
      domain: /twitter/
    },
    prefix
  };
  const vimeo = {
    id: "vimeo",
    preferredUrl: `https://vimeo.com/${profileReplacement.user}`,
    matcher: {
      domain: /vimeo/
    }
  };
  const yat = {
    id: "yat",
    preferredUrl: `https://y.at/${profileReplacement.user}`,
    matcher: {
      domain: /^y$/
    }
  };
  const youtube = {
    id: "youtube",
    preferredUrl: `https://youtube.com/channel/${profileReplacement.user}`,
    appUrl: `https://m.youtube.com/c/${profileReplacement.user}`,
    matcher: {
      // TODO: Worth considering if we match against short URLs.
      // https://github.com/beefchimi/socialite/issues/21
      domain: /youtube/,
      // Not currently supporting the legacy `/user/*` URL.
      user: /^\/(?:channel|c)\/([^/]+)/
    }
  };
  const networks = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    behance,
    devto,
    discord,
    dribbble,
    exercism,
    facebook,
    github,
    instagram,
    keybase,
    linkedin,
    medium,
    onlyfans,
    patreon,
    pinterest,
    reddit,
    stackoverflow,
    substack,
    telegram,
    tiktok,
    twitch,
    twitter,
    vimeo,
    yat,
    youtube
  }, Symbol.toStringTag, { value: "Module" }));
  const defaultSocialiteNetworks = [
    facebook,
    instagram,
    linkedin,
    reddit,
    tiktok,
    twitch,
    twitter,
    youtube
  ];
  const socialiteNetworks = { ...networks };
  function filterNetworkProperties(network, subset) {
    const uniqueProperties = beeftools.arrayDedupe(subset);
    const keys = beeftools.typedObjectKeys(network);
    return uniqueProperties.length ? keys.reduce(
      (filtered, property) => uniqueProperties.includes(property) ? {
        ...filtered,
        // BUG: At the moment, TypeScript seems to think that
        // any `{key: value}` pair is acceptable here.
        // https://github.com/beefchimi/socialite/issues/9
        [property]: network[property]
      } : filtered,
      {}
    ) : network;
  }
  function mergeRegExp(...expressions) {
    const source = expressions.map((exp) => exp.source).join("");
    const flags = beeftools.arrayDedupe(
      expressions.map((exp) => exp.flags.split("")).flat()
    ).join("");
    return { source, flags };
  }
  function updateGroupsWithSubdomain(groups) {
    const { domain } = groups;
    let updatedSubdomain;
    let updatedDomain;
    if (domain) {
      const lastDot = domain.lastIndexOf(".");
      const bypass = lastDot === -1;
      updatedSubdomain = bypass ? void 0 : domain.slice(0, lastDot + 1);
      updatedDomain = bypass ? void 0 : domain.slice(lastDot + 1);
    }
    return {
      ...groups,
      ...updatedSubdomain ? { subdomain: updatedSubdomain } : {},
      ...updatedDomain ? { domain: updatedDomain } : {}
    };
  }
  function getUrlGroups(url = "") {
    const matched = url.trim().match(urlRegExp);
    if (!(matched == null ? void 0 : matched.groups))
      return null;
    const filtered = beeftools.objFilterNullish(matched.groups);
    return updateGroupsWithSubdomain(filtered);
  }
  function getUrlWithSubstitutions(url = "", user = "", prefix2 = "") {
    return url.replace(profileReplacement.user, user).replace(profileReplacement.prefix, prefix2);
  }
  function getDiscordPreferredUrl({
    tldomain,
    path,
    user
  }) {
    if (path == null ? void 0 : path.startsWith("/users/")) {
      return getUrlWithSubstitutions(discordPreferredUrls.users, user);
    }
    if (path == null ? void 0 : path.startsWith("/channels/")) {
      return getUrlWithSubstitutions(discordPreferredUrls.channels, user);
    }
    if (tldomain === ".gg") {
      return getUrlWithSubstitutions(discordPreferredUrls.vanity, user);
    }
    return getUrlWithSubstitutions(discordPreferredUrls.default, user);
  }
  class Socialite {
    constructor(customNetworks = []) {
      __privateAdd(this, _validateUrl);
      __privateAdd(this, _getMinimumResult);
      __privateAdd(this, _networks, void 0);
      const initialNetworks = customNetworks.length ? customNetworks : defaultSocialiteNetworks;
      __privateSet(this, _networks, /* @__PURE__ */ new Map());
      initialNetworks.forEach((network) => this.addNetwork(network));
    }
    hasNetwork(id = "") {
      return __privateGet(this, _networks).has(id);
    }
    addNetwork(network, overwrite = false) {
      return !overwrite && this.hasNetwork(network.id) ? false : __privateGet(this, _networks).set(network.id, network);
    }
    removeNetwork(id = "") {
      return __privateGet(this, _networks).delete(id);
    }
    emptyNetworks() {
      __privateGet(this, _networks).clear();
    }
    getNetwork(id = "") {
      return __privateGet(this, _networks).get(id);
    }
    getAllNetworks(subset) {
      return [...__privateGet(this, _networks).values()].map(
        (network) => subset ? filterNetworkProperties(network, subset) : network
      );
    }
    getNetworkFromDomain(domain = "") {
      let matchedNetwork;
      for (const [_id, network] of __privateGet(this, _networks)) {
        const match = new RegExp(network.matcher.domain).test(domain);
        if (match) {
          matchedNetwork = network;
          break;
        }
      }
      return matchedNetwork;
    }
    getPreferredUrl(id = "", user = "") {
      if (!this.hasNetwork(id))
        return false;
      const { preferredUrl, prefix: prefix2 } = this.getNetwork(id) ?? {};
      return getUrlWithSubstitutions(preferredUrl, user, prefix2);
    }
    parseUrl(url = "") {
      const groups = getUrlGroups(url);
      return __privateMethod(this, _validateUrl, validateUrl_fn).call(this, groups) ? groups : false;
    }
    parseProfile(value, id = "") {
      const groups = typeof value === "string" ? this.parseUrl(value) : value;
      if (!groups || id.length && !this.hasNetwork(id))
        return false;
      const targetNetwork = this.hasNetwork(id) ? this.getNetwork(id) : this.getNetworkFromDomain(groups.domain);
      if (!targetNetwork)
        return false;
      const minResult = __privateMethod(this, _getMinimumResult, getMinimumResult_fn).call(this, targetNetwork, groups, typeof value === "string" ? value : void 0);
      const useSubdomain = targetNetwork.matcher.userSource === MatchUserSource.Subdomain;
      const userSource = useSubdomain ? groups.subdomain : groups.path;
      if (!userSource || Boolean(!useSubdomain && groups.path === "/")) {
        return minResult;
      }
      const fallbackMatcher = useSubdomain ? defaultUserMatcher.subdomain : defaultUserMatcher.path;
      const userRegExp = targetNetwork.matcher.user ? new RegExp(targetNetwork.matcher.user) : fallbackMatcher;
      const prefix2 = targetNetwork.prefix;
      const matchedUser = userSource.match(userRegExp);
      const user = matchedUser ? matchedUser[matchedUser.length - 1].replace(prefix2 ?? "", "") : void 0;
      if (!user)
        return minResult;
      const preferredUrl = targetNetwork.id === "discord" ? getDiscordPreferredUrl({
        tldomain: minResult.urlGroups.tldomain,
        path: minResult.urlGroups.path,
        user
      }) : getUrlWithSubstitutions(targetNetwork.preferredUrl, user, prefix2);
      const appUrl = targetNetwork.appUrl ? getUrlWithSubstitutions(targetNetwork.appUrl, user, prefix2) : void 0;
      return {
        ...minResult,
        ...appUrl ? { appUrl } : {},
        ...prefix2 ? { prefix: prefix2 } : {},
        preferredUrl,
        user
      };
    }
    fixUrlScheme(url = "") {
      return schemeRegExp.test(url) ? url : `https://${url}`;
    }
    mergeGroupsToUrl(groups) {
      const orderedValues = [
        groups.scheme,
        groups.subdomain,
        groups.domain,
        groups.tldomain,
        groups.port,
        groups.path,
        groups.parameters,
        groups.anchor
      ];
      return orderedValues.filter((value) => value !== void 0).join("");
    }
  }
  _networks = new WeakMap();
  _validateUrl = new WeakSet();
  validateUrl_fn = function(groups) {
    const { domain, tldomain } = groups ?? {};
    return Boolean((domain == null ? void 0 : domain.length) && (tldomain == null ? void 0 : tldomain.length));
  };
  _getMinimumResult = new WeakSet();
  getMinimumResult_fn = function(network, groups, url = "") {
    const originalUrl = url.length ? url : this.mergeGroupsToUrl(groups);
    return {
      id: network.id,
      urlGroups: groups,
      originalUrl,
      preferredUrl: getUrlWithSubstitutions(network.preferredUrl),
      ...network.appUrl ? { appUrl: getUrlWithSubstitutions(network.appUrl) } : {}
    };
  };
  exports2.MatchUserSource = MatchUserSource;
  exports2.Socialite = Socialite;
  exports2.UrlCaptureId = UrlCaptureId;
  exports2.defaultSocialiteNetworks = defaultSocialiteNetworks;
  exports2.defaultUserMatcher = defaultUserMatcher;
  exports2.filterNetworkProperties = filterNetworkProperties;
  exports2.getDiscordPreferredUrl = getDiscordPreferredUrl;
  exports2.getUrlGroups = getUrlGroups;
  exports2.getUrlWithSubstitutions = getUrlWithSubstitutions;
  exports2.mergeRegExp = mergeRegExp;
  exports2.profileReplacement = profileReplacement;
  exports2.schemeRegExp = schemeRegExp;
  exports2.socialiteNetworks = socialiteNetworks;
  exports2.socialitePrefix = socialitePrefix;
  exports2.urlCaptureGroup = urlCaptureGroup;
  exports2.urlRegExp = urlRegExp;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
